## debci 3.5.2

=== debian/changelog ===
debci (3.5.2) unstable; urgency=medium

  [ Antonio Terceiro ]
  * config: improve handling of MIRROR.
    MIRROR is no longer read, and is only set if debci_mirror was
    explicitly set in the debci configuration.
  * debci-generate-apt-sources: handle ports architectures
  * debci-localtest: fix --help

 -- Paul Gevers <elbrus@debian.org>  Thu, 07 Jul 2022 21:30:42 +0200

debci (3.5.1) unstable; urgency=medium

  * Debci::App: get query parameters implicitly for pagination links
  * templates: job_listing: drop trailing whitespace
  * templates: job_listing: make package name a link

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 30 Mar 2022 09:39:12 -0300

debci (3.5) unstable; urgency=medium

  [ Antonio Terceiro ]
  * frontend: package: always display a pending jobs header
  * spec_helper: point Debci.config.data_basedir at temp directory
  * debci-test: don't repeat --add-apt-release= options (Closes: #968679)
  * debci-worker: move lxc | schroot from Depends: to Recommends:
  * Add tests for Debci::Job#expired?
  * Drop generation and storage of package-specific static data files
  * Delete remaining status HTML files
  * ci: run tests against postgresql
  * docs: don't advertise the schroot autopkgtesst backend
  * docs: MAINTAINERS: remove lxc networking instructions
  * .gitlab-ci.yml: upgrade stable to bullseye
  * .gitlab-ci.yml: don't hardcode the stable release
  * debci-worker: name temporary directory better
  * debci-worker: ensure temporary dir removal
  * backends/lxc: ensure temporary customize script is removed
  * Debci::HTML.update_package: drop deprecated arguments
  * debci-html: exit non-zero on wrong usage
  * Debci::Status: add trailing slashes everywhere for consistency

  [ barakat-ajadi ]
  * Status: generate status page dynamic
  * Status: Add pagination and filter to status pages

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 27 Mar 2022 16:37:07 -0300

## debci 3.5.2+nmu1

=== debian/changelog ===
debci (3.5.2+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 11:59:21 +0200

=== debian/control ===
Source: debci
Section: devel
Priority: optional
Maintainer: Debian CI team <team+ci@tracker.debian.org>
Uploaders: Antonio Terceiro <terceiro@debian.org>, Paul Gevers <elbrus@debian.org>,
Build-Depends: debhelper-compat (= 12),
               debootstrap,
               amqp-tools,
               autopkgtest (>= 5.5~) <!pkg.debci.runtime>,
               curl,
               dctrl-tools,
               debian-archive-keyring,
               devscripts,
               distro-info,
               fonts-font-awesome (>= 4.0.3~),
               inotify-tools <!pkg.debci.runtime>,
               jq,
               libjs-bootstrap,
               libjs-jquery,
               libjs-jquery-flot,
               moreutils,
               patchutils,
               postgresql <!pkg.debci.runtime>,
               rabbitmq-server <!pkg.debci.runtime>,
               rerun <!pkg.debci.runtime>,
               retry,
               rsync,
               ruby,
               ruby-activerecord (>= 2:5.2),
               ruby-bunny,
               ruby-database-cleaner <!pkg.debci.runtime>,
               ruby-erubi,
               ruby-foreman <!pkg.debci.runtime>,
               ruby-omniauth-gitlab,
               ruby-pg,
               ruby-rack-test <!pkg.debci.runtime>,
               ruby-rspec (>= 2.14) <!pkg.debci.runtime>,
               ruby-sinatra,
               ruby-sinatra-contrib,
               ruby-kaminari-activerecord,
               ruby-sqlite3,
               ruby-thor,
               shellcheck <!pkg.debci.runtime>,
               shunit2 <!pkg.debci.runtime>,
               yard <!pkg.debci.runtime>,
Standards-Version: 4.4.1
Homepage: http://ci.debian.net/
Vcs-Git: https://salsa.debian.org/ci-team/debci.git
Vcs-Browser: https://salsa.debian.org/ci-team/debci
Rules-Requires-Root: no

Package: debci
Architecture: all
Depends: adduser,
         debootstrap,
         ruby-sqlite3 | ruby-pg,
         sudo,
         ${debci:Depends},
         ${misc:Depends},
Recommends: ntp | time-daemon
Suggests: apt-cacher-ng, auto-apt-proxy
Description: continuous integration system for Debian
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package contains the debci core.

Package: debci-worker
Architecture: all
Depends: debci (= ${binary:Version}),
         autodep8 (>= 0.2~),
         autopkgtest (>= 5.5~),
         ${misc:Depends},
Recommends: lxc | schroot,
Description: continuous integration system for Debian (worker daemon)
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package provides cron and init integration for running debci worker
 daemons that will listen to AMQP queues and run test jobs.

Package: debci-collector
Architecture: all
Depends: debci (= ${binary:Version}),
         ${misc:Depends},
Breaks: debci (<< 2.6~)
Replaces: debci (<< 2.6~)
Recommends: rabbitmq-server,
Description: continuous integration system for Debian (collector daemon)
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package provides the collector daemon, which will receive test results
 published by debci worker hosts, store them centrally, and generate the static
 HTML files for the debci user interface.

## debci 3.6

=== Makefile ===
all: doc

include links.mk

links.mk: links
	awk '{ print("LINKS +=", $$1); print($$1, ":"); print("\ttest -e ", $$2); print("\tmkdir -p $$(shell dirname ", $$1, ")"); print("\tln -sf", $$2, $$1)}' $^ > $@

MANPAGES = $(patsubst bin/%, man/%.1, $(shell grep -rl =head1 bin/*))

all: $(LINKS) $(MANPAGES)

.PHONY: spec check test quick-check

checkdeps:
	@if which dpkg-checkbuilddeps >/dev/null && which grep-dctrl >/dev/null; then dpkg-checkbuilddeps -d "$$(grep-dctrl -n -s Depends . debian/control | grep -v '\$$')"; fi

export COVERAGE = no

spec:
	@./test/banner 'Ruby unit tests'
	rspec --color

spec-postgresql:
	@./test/banner 'Ruby unit tests (PostgreSQL)'
	pg_virtualenv sh -c 'DATABASE_URL=postgresql:///$$PGDATABASE rspec --color'


functional-tests:
	@./test/banner 'Functional tests'
	test/runall.sh
	$(RM) -v test/erl_crash.dump

backends = $(shell ls -1 backends/)
test_backends = $(patsubst %, test-%, $(backends))
.PHONY: $(test_backends)

test-backends: $(test_backends)

$(test_backends): test-% : backends/%/test-package
	@./test/banner "Test backend $*"
	./bin/debci test -b $* test/fake-package/ > log/test-$*.log 2>&1 # local source package
	./bin/debci test -b $* ruby-defaults      > log/test-$*.log 2>&1 # source package from archive

deb:
	mkdir -p tmp/deb
	rm -rf tmp/deb/debci*
	DEB_BUILD_OPTIONS=nocheck gbp buildpackage --git-ignore-branch --git-export-dir=tmp/deb
	cd tmp/deb && dpkg-scanpackages . > Packages
	@echo
	@echo "Debian packages available in tmp/deb/!"

ruby-console:
	./bin/debci shell

check: all check-ui-and-docs check-ruby-style check-shell codespell spec spec-postgresql functional-tests

check-ui-and-docs: all
	test -d public/doc
	test -f public/doc/index.html
	test -L public/doc/js/jquery.js -a -f public/doc/js/jquery.js
	test -L public/jquery.js -a -f public/jquery.js
	test -L public/bootstrap

check-ruby-style:
	if type rubocop; then rubocop; fi

check-shell:
	./tools/check-shell-scripts.sh

codespell:
	if type codespell; then codespell; fi

test: check

quick-check: check-ruby-style check-shell codespell spec

doc: public/doc/index.html public/doc/architecture.svg

public/doc/index.html public/doc/jq/jquery.js: README.md $(sort $(wildcard docs/*.md)) $(shell find lib -name '*.rb' | LC_ALL=C sort)
	$(RM) public/doc/js/jquery.js
	yardoc --markup markdown --output-dir public/doc --main README.md lib - $^
	ln -sf ../../jquery.js public/doc/js/jquery.js

public/doc/architecture.svg: docs/architecture.svg public/doc
	cp docs/architecture.svg public/doc/

public/doc:
	mkdir -p $@

$(MANPAGES): man/%.1: bin/% man
	pod2man --center "" --release "" --section=1 --utf8 $< $@

man:
	mkdir $@

.PHONY: tags

tags:
	ctags -R --exclude=data --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .

clean:
	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS) man/

=== debian/changelog ===
debci (3.6) unstable; urgency=medium

  [ Louis-Philippe Véronneau ]
  * docs: more precise info on how to get an API key
  * docs: remove mention of deprecated getkey endpoint

  [ Antonio Terceiro ]
  * RejectList: pre-expand wildcards when reading the data
  * Debci::Status: make code backwards compatible with ruby2.5
  * web frontend: rework user authentication
  * web frontend: add simple admin interface
  * self_service: make auth config forward-compatible with omniauth-gitlab 4.0
  * Debci::Job: store file sizes for log and artifacts
  * usage: fix help message for backend option
  * debci-worker: fix running alternative architectures and backends on the
    same host
  * admin: add support for stable ordering of records
  * admin: add Package.backend and support for select fields in general
  * admin: search packages by backend; fix searching on more than one field
  * Backend: use package preferred backend if available
  * debci-worker: mention backend in the logs
  * Debci::AMQP: don't cache queue name per architecture
  * api: add entry point to retry tests via a POST request
  * Apply suggestions by rubocop 1.39.0
  * tools/server.sh: use puma explicitly instead of rackup
  * test/test_helper.sh: setup custom management plugin port
  * test/bin/wait_for_results: simplify getting timestamp of last test job
  * Acknowledge NMU by Michael Biebl
  * Debci::Job: avoid artifact filenames being interpreted as tar options
    (Closes: #1030883)
  * Debci::Job: produce one single pin-package parameter with multiple
    packages (Closes: #1025369)
  * debci generate-apt-sources: add support for non-free-firmware
    (Closes: #1031238)

  [ Pavit Kaur ]
  * Handle signing-keys for extra-apt-sources

  [ Bas Couwenberg ]
  * Fix architecture list in JSON export.

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 26 Feb 2023 12:08:48 -0300

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,7 @@
                moreutils,
                patchutils,
                postgresql <!pkg.debci.runtime>,
+               puma <!pkg.debci.runtime>,
                rabbitmq-server <!pkg.debci.runtime>,
                rerun <!pkg.debci.runtime>,
                retry,
@@ -31,6 +32,7 @@
                ruby-database-cleaner <!pkg.debci.runtime>,
                ruby-erubi,
                ruby-foreman <!pkg.debci.runtime>,
+               ruby-localhost <!pkg.debci.runtime>,
                ruby-omniauth-gitlab,
                ruby-pg,
                ruby-rack-test <!pkg.debci.runtime>,

=== test/test-package-large-logs/debian/tests/control ===
Tests: generate-large-log
Depends: perl

## debci 3.9

=== Makefile ===
--- 
+++ 
@@ -68,7 +68,7 @@
 	./tools/check-shell-scripts.sh
 
 codespell:
-	if type codespell; then codespell; fi
+	if type codespell; then codespell --ignore-words tools/codespell-ignore.txt; fi
 
 test: check
 
@@ -96,7 +96,7 @@
 .PHONY: tags
 
 tags:
-	ctags -R --exclude=data --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .
+	ctags -R --exclude=data --exclude='public/jquery*' --exclude=public/bootstrap --exclude=public/doc --exclude=public/font-awesome --exclude=coverage --exclude=config .
 
 clean:
 	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS) man/

=== debian/changelog ===
debci (3.9) unstable; urgency=medium

  * web ui: reduce usage of automatic page refresh
  * Debci::Log: handle non-UTF-8 data correctly
  * Drop static index.html in favor of Debci::Home app
  * Move RSS feed to be dynamically generated
  * Debci::HTML: load package statuses in batches
  * debian-update.timer: reduce frequency to hourly
  * Debci::Log: mark uninstallable sections as failures
  * log viewer: don't collapse a single subsection of failure sections

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 10 Dec 2023 21:18:35 -0300

debci (3.8) unstable; urgency=medium

  [ Christian Kastner ]
  * debci-localtest can also take autopkgtest backends
  * Add debci_autopkgtest_args_<backend> to environment.sh

  [ Antonio Terceiro ]
  * Debci::StorageLimit: only count non-deleted jobs
  * Debci::StorageLimit: traverse only non-deleted jobs
  * Debci::Job: ensure files_purged is false
  * debci-collector.postinst: drop support for upgrades from buster
  * spec: ensure a reasonable value for Debci.config.html_dir.
    This fixes running the Ruby test suite under autopkgtest using a
    different user than `debci`.
  * munin: debci_packages_processed: look into debci-publisher logs
  * web ui: add structured log viewer.
    An initial version in client side JavaScript was written by Stuart
    Prescott. It was then used as base for the the server side Ruby version
    by Antonio Terceiro. In special, all the regular expressions were copied
    as-is from Stuart's original code.
    If Javascript is enabled, then there is some extra functionality, like
    collapsing non-critical sessions and leaving only the actual test runs
    visible by default.

  [ Helmut Grohne ]
  * Install units with dh_installsystemd only (Closes: #1054188)

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 16 Nov 2023 08:19:07 -0300

debci (3.7) unstable; urgency=medium

  [ Antonio Terceiro ]
  * Split publishing of results into a separate daemon
  * Debci::Job: store and report backend
  * Make logging for all daemons consistent
  * debci-worker, debci-publisher: log errors even in quiet mode
  * debci-generate-apt-sources: fix checks for non-free-firmware for suite codenames
  * self_service: allow multiple API keys and add to manage them
  * spec_helper: bump required test coverage to 92%
  * Drop obsolete scripts and mentions to them.
    Since debci-batch has been removed in favor of external scheduling of
    tests, some infrastructure left behind is not really useful anymore.
    Right now, drop  debci-list-dependencies, debci-list-packages,
    debci-setup-chdist and references to them (which are unused anyway).
  * Drop schroot backend
  * Bump dependency on autopkgtest to >= 5.29~
  * debci-publisher: fix obtaining data for logging
  * Drop dependency on devscripts
  * collector_spec: fix typo
  * Debci::Job.receive: improve handling of incomplete test results
  * debci-publisher: resist corrupted result archives
  * Debci::Job: keep track of purged files separate from the expiration date
  * config: define a disk storage limit per package
  * Debci::Job: add method to calculate per-job disk usage
  * Limit amount of storage each package can use.
    By Default, each package is allowed to use up to 200MB of disk space
    with logs and artifacts.
  * Debci::Status: remove unused variables
  * web: /status/{alerts,pending}/: display total of jobs after filtering
  * Debci::App: inform total of records when paginating
  * .rerun: ignore coverage/
  * web: display information about expired test logs.
    The custom 404 page for test logs will provide links to the list of
    tests for th same package on the suite and architecture of the original
    test, and for retrying the original test.
  * spec_helper: bump require test coverage to 93%

  [ Helmut Grohne ]
  * backends/lxc/create-testbed: use fewer different sources.lists
  * backends/qemu: fix evaluation of undefined variable
  * backends/qemu/create-testbed: use fewer different sources.lists
  * debci setup: add --keyring option
  * backends/qemu/create-testbed: forward --keyring
  * backends/lxc/create-testbed: pass keyring via new --keyring to autopkgtest-build-lxc
  * debci-setup: conditionalize installation of auto-apt-proxy
  * backends/lxc/create-testbed: do not enable --dbgsym for Debian derivatives
  * import and install munin plugins from debian-ci-config
  * Allow passing arguments to autopkgtest backends (Closes: #1037245)

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 04 Nov 2023 10:48:18 -0300

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,13 @@
 Build-Depends: debhelper-compat (= 12),
                debootstrap,
                amqp-tools,
-               autopkgtest (>= 5.5~) <!pkg.debci.runtime>,
+               autopkgtest (>= 5.29~) <!pkg.debci.runtime>,
                curl,
                dctrl-tools,
                debian-archive-keyring,
-               devscripts,
                distro-info,
                fonts-font-awesome (>= 4.0.3~),
-               inotify-tools <!pkg.debci.runtime>,
+               inotify-tools,
                jq,
                libjs-bootstrap,
                libjs-jquery,
@@ -33,6 +32,7 @@
                ruby-erubi,
                ruby-foreman <!pkg.debci.runtime>,
                ruby-localhost <!pkg.debci.runtime>,
+               ruby-magic <!pkg.debci.runtime>,
                ruby-omniauth-gitlab,
                ruby-pg,
                ruby-rack-test <!pkg.debci.runtime>,
@@ -77,10 +77,11 @@
 Package: debci-worker
 Architecture: all
 Depends: debci (= ${binary:Version}),
+         inotify-tools,
          autodep8 (>= 0.2~),
-         autopkgtest (>= 5.5~),
+         autopkgtest (>= 5.29~),
          ${misc:Depends},
-Recommends: lxc | schroot,
+Recommends: lxc
 Description: continuous integration system for Debian (worker daemon)
  debci will scan the Debian archive for packages that contain DEP-8 compliant
  test suites, and run those test suites whenever a new version of the package,

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Run only Ruby tests during build
	make spec
endif

override_dh_gencontrol:
	debian/gen-deps >> debian/debci.substvars
	dh_gencontrol

override_dh_installinit:
	@true

execute_after_dh_installsystemd:
	dh_installsystemd -pdebci-collector --name=debci-update
	dh_installsystemd -pdebci-worker --name=debci-publisher

override_dh_install:
	dh_install
	debian/sanity-check

=== debian/tests/control ===
Tests: ruby-test-suite
Depends: debci-collector, shunit2, ruby-database-cleaner, ruby-rspec (>= 2.14), ruby-magic, ruby-rack-test, rabbitmq-server, autopkgtest
Restrictions: allow-stderr

Tests: test-suite
Depends: debci-collector, shunit2, ruby-database-cleaner, rabbitmq-server, autopkgtest
Restrictions: allow-stderr, flaky

Tests: integration-test
Depends: debci, shunit2, rabbitmq-server
Restrictions: allow-stderr, isolation-container, needs-root, breaks-testbed

Tests: multiarch-integration-test
Depends: debci, shunit2, rabbitmq-server
Restrictions: allow-stderr, isolation-container, needs-root, breaks-testbed

Tests: backend-lxc
Depends: debci, libnss-myhostname, netcat-openbsd, redir, autopkgtest, lxc, lxc-templates, rsync, libvirt-clients, libvirt-daemon-system, iptables, ebtables, dnsmasq-base
Restrictions: allow-stderr, isolation-machine, needs-root

# vim: ft=debcontrol

## debci 3.10

=== debian/changelog ===
debci (3.10) unstable; urgency=medium

  [ Christian Kastner ]
  * worker: Add --count option to enable job limit

  [ Antonio Terceiro ]
  * api: don't use automatically updated timestamp for filtering
  * db: add index on jobs.date
  * api: clarify documentation for /tests endpoint
  * api: complete examples in documentation to list all job fields
  * api: /v1/tests: return only documented fields
  * api, self_service: fix performance issues in ActiveRecord queries
  * /api/v1/test: include updated_at field in the results
  * Debci::Job: declare public API fields here
  * Debci::Job: add date attribute to the public API
  * Debci::HTML: avoid N+1 queries when loading package status
  * Debci::HTML: export only public API attributes of jobs
  * admin: display model-related icon inside edit page
  * admin: edit: show object name (#to_str) in the breadcrumbs
  * backends: fake: remove obsolete debci-setup-chdist script
  * doc: exclude frames.html

  [ g0t mi1k ]
  * Switch to Debian Bookworm (12) for Vagrant
  * Dynamically update codename for vagrant
  * Fix typo - extra \
  * debci-config: Allow for displaying all KEY values
  * debci-config: Switch to --all to list all keys
  * Add Setting up the LXC backend testbed
  * Add Setting up PostgreSQL database
  * Add Accessing Self Service (Web UI)
  * Add Creating API tokens
  * Configuring debci using variables & configs
  * Add Multiple debci-worker processes per node
  * Typo: t -> T
  * debci-status: Fix typo - Missing hyphen
  * debci-status: JSON loop on packages not results
  * debci-status: Fix static arch & suite flags
  * debci-status: More consistency with output
  * Update HACKING.md as 'debci config' can list all
  * escape /auth/failure params[:message]

  [ Paul Gevers ]
  * Apply suggestions to INSTALL.md
  * lxc/test-package: fix order of debci_autopkgtest_args_lxc (Closes: 1068380)

  [ Tiago Zaniquelli ]
  * Redirect search result directly to package page if there's only one answer.

  [ Helmut Grohne ]
  * collector: skip over results that refer to an unknown job

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 17 Apr 2024 20:53:49 -0300

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
                rsync,
                ruby,
                ruby-activerecord (>= 2:5.2),
+               ruby-bullet <!pkg.debci.runtime>,
                ruby-bunny,
                ruby-database-cleaner <!pkg.debci.runtime>,
                ruby-erubi,

=== debian/tests/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Tests: ruby-test-suite
-Depends: debci-collector, shunit2, ruby-database-cleaner, ruby-rspec (>= 2.14), ruby-magic, ruby-rack-test, rabbitmq-server, autopkgtest
+Depends: debci-collector, shunit2, ruby-database-cleaner, ruby-rspec (>= 2.14), ruby-magic, ruby-rack-test, ruby-bullet, rabbitmq-server, autopkgtest
 Restrictions: allow-stderr
 
 Tests: test-suite

## debci 3.11

=== Makefile ===
--- 
+++ 
@@ -79,6 +79,7 @@
 public/doc/index.html public/doc/jq/jquery.js: README.md $(sort $(wildcard docs/*.md)) $(shell find lib -name '*.rb' | LC_ALL=C sort)
 	$(RM) public/doc/js/jquery.js
 	yardoc --markup markdown --output-dir public/doc --main README.md lib - $^
+	$(RM) public/doc/frames.html
 	ln -sf ../../jquery.js public/doc/js/jquery.js
 
 public/doc/architecture.svg: docs/architecture.svg public/doc

=== debian/changelog ===
debci (3.11) unstable; urgency=medium

  [ Antonio Terceiro ]
  * log_viewer: display link to download artifacts (Closes: #1072049)
  * debci-test: remove tests-tree from autopkgtest results
  * web ui: package: link to the test history even without reference data
  * debci-setup: keep only 20 days of logs
  * Debci::StorageLimit: respect a per-package storage limit
  * admin: packages: support nicely formatted storage sizes
  * log_viewer: don't special case logs with only 1 section
  * debci-api: auth: fix username output
  * self service: validate suite and architecture
  * self service: improve markup for architecture and suite
  * debci limit-storage: add `cleanup` subcommand to act on a single package
  * debci limit-storage: add subcommand to list packages
  * autopkgtest: backend-lxc: drop unecessary network setup
  * autopkgtest: backend-lxc: add missing dependency on uidmap
  * Debci::Backend: select backend from Debci.config.backend_list as well
  * api: improve wording for rejected package
  * api: silently ignore invalid test requests
  * self service: job history: link to log viewer
  * log_viewer: interpret ANSI escape codes and display colors.
    The raw logs are still transmitted unmodified, and need to be opened in
    a tool that can handle the escape codes. (Closes: #985960)
  * log_viewer: add navigation breadcrumbs to the top

  [ Christian Kastner ]
  * Allow symlinks in conf.d
  * debci-enqueue: Add support for --extra-apt-sources
  * Add support for nested strings in autopkgtest

  [ Paul Gevers ]
  * status: add a line for pass+neutral in the percentage graph

  [ Arnaud Rebillout ]
  * Debci::Job: add duration_seconds attributes to the public API

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 30 Jan 2025 19:48:21 +0100

## debci 3.12

=== Makefile ===
--- 
+++ 
@@ -9,12 +9,12 @@
 
 all: $(LINKS) $(MANPAGES)
 
-.PHONY: spec check test quick-check
+.PHONY: spec check test quick-check coverage
 
 checkdeps:
 	@if which dpkg-checkbuilddeps >/dev/null && which grep-dctrl >/dev/null; then dpkg-checkbuilddeps -d "$$(grep-dctrl -n -s Depends . debian/control | grep -v '\$$')"; fi
 
-export COVERAGE = no
+export COVERAGE ?= no
 
 spec:
 	@./test/banner 'Ruby unit tests'
@@ -24,6 +24,9 @@
 	@./test/banner 'Ruby unit tests (PostgreSQL)'
 	pg_virtualenv sh -c 'DATABASE_URL=postgresql:///$$PGDATABASE rspec --color'
 
+
+coverage:
+	$(MAKE) spec COVERAGE=yes
 
 functional-tests:
 	@./test/banner 'Functional tests'

=== debian/changelog ===
debci (3.12) unstable; urgency=medium

  * debian/changelog: fix typo found by codespell
  * frontend: log_viewer: redirect to raw log when plain text is requested
  * debci limit-storage: fix call to #packages_with_excess_storage
  * Makefile: add target to check code coverage
  * Add support for ActiveRecord 7 (Closes: #1095874)
    * Debci::DB: add support for running migrations on ActiveRecord 7
    * Debci::Job: explicitly cast ActiveRecord::Duration into a float
    * Debci::Job: modernize declaration of serialized fields

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 26 Feb 2025 11:58:31 -0300

=== test/fake-package/debian/changelog ===
fake-package (0.1.0~FIXME-1) UNRELEASED; urgency=medium

  * Initial release (Closes: #nnnn)

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 24 Jul 2015 14:11:19 -0300

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
                rsync,
                ruby,
                ruby-activerecord (>= 2:5.2),
+               ruby-ansi,
                ruby-bullet <!pkg.debci.runtime>,
                ruby-bunny,
                ruby-database-cleaner <!pkg.debci.runtime>,
@@ -42,6 +43,7 @@
                ruby-sinatra-contrib,
                ruby-kaminari-activerecord,
                ruby-sqlite3,
+               ruby-table-print,
                ruby-thor,
                shellcheck <!pkg.debci.runtime>,
                shunit2 <!pkg.debci.runtime>,

=== test/fake-package/debian/control ===
Source: fake-package
Section: ruby
Priority: optional
Maintainer: Antonio Terceiro <terceiro@debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.6
Testsuite: autopkgtest

Package: fake-package
Architecture: all
Depends: dpkg
Description: fake package to test debci backends
 Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum pharetra
 nisi quis justo tincidunt, sed dictum neque rhoncus. Aliquam in nisl a sem
 tempus feugiat. Ut lacinia vulputate orci at gravida. Vivamus elit ante,
 interdum in risus nec, lacinia commodo purus. Quisque mollis magna nunc, non
 tincidunt neque fringilla non.

=== debian/tests/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Restrictions: allow-stderr, isolation-container, needs-root, breaks-testbed
 
 Tests: backend-lxc
-Depends: debci, libnss-myhostname, netcat-openbsd, redir, autopkgtest, lxc, lxc-templates, rsync, libvirt-clients, libvirt-daemon-system, iptables, ebtables, dnsmasq-base
+Depends: debci, libnss-myhostname, netcat-openbsd, redir, autopkgtest, lxc, lxc-templates, rsync, iptables, ebtables, dnsmasq-base, uidmap
 Restrictions: allow-stderr, isolation-machine, needs-root
 
 # vim: ft=debcontrol

## debci 3.12+ciai2

=== debian/changelog ===
debci (3.12+ciai2) unstable; urgency=medium

  * Bump autopkgtest version to one with qemu directory sharing.
    I added this to upstream, but upstream hasn't cut a release yet. I've
    created a temporary release in the Debian AI APT Archive.

 -- Christian Kastner <ckk@debian.org>  Sat, 27 Sep 2025 09:42:28 +0200

debci (3.12+ciai1) unstable; urgency=medium

  * Fork of debci for ci.ai.debian.net, for prototyping AI hardware support

  * Bump dependencies for autopkgtest and vmdb2
  * Basic arch+variant support, eg: amd64+variant
  * Add qemu+rocm backend
  * Add podman+rocm backend
  * Add qemu+cuda backend
  * Add config-aware systemd service files
  * Add hooks for pre- and post-test commands
  * Add list-worker-gpus utility
  * Add pre-test utility based on gpuenv-utils
  * Add ability to force backend for an architecture
  * debci-update-worker: Add support for multiple configs
  * worker: Make the AMQP consumer binary a configurable option
  * worker: Add new gpuenv-aware AMQP consumer

 -- Christian Kastner <ckk@debian.org>  Thu, 04 Sep 2025 22:50:04 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 12),
                debootstrap,
                amqp-tools,
-               autopkgtest (>= 5.29~) <!pkg.debci.runtime>,
+               autopkgtest (>= 5.31~) <!pkg.debci.runtime>,
                curl,
                dctrl-tools,
                debian-archive-keyring,
@@ -82,9 +82,12 @@
 Depends: debci (= ${binary:Version}),
          inotify-tools,
          autodep8 (>= 0.2~),
-         autopkgtest (>= 5.29~),
+         autopkgtest (>= 5.51+git20250918~),
+         vmdb2 (>= 0.40~),
+         python3-pika,
+         gpuenv-server (>= 0.1.7),
          ${misc:Depends},
-Recommends: lxc
+Recommends: lxc, gpu-qemu-support, gpu-podman-support
 Description: continuous integration system for Debian (worker daemon)
  debci will scan the Debian archive for packages that contain DEP-8 compliant
  test suites, and run those test suites whenever a new version of the package,

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,10 @@
 
 execute_after_dh_installsystemd:
 	dh_installsystemd -pdebci-collector --name=debci-update
-	dh_installsystemd -pdebci-worker --name=debci-publisher
+	dh_installsystemd -pdebci-worker --name=debci-worker-byconf
+	dh_installsystemd -pdebci-worker --name=debci-worker-byconf@
+	dh_installsystemd -pdebci-worker --name=debci-publisher-byconf
+	dh_installsystemd -pdebci-worker --name=debci-publisher-byconf@
 
 override_dh_install:
 	dh_install

## debci 3.13

=== Makefile ===
--- 
+++ 
@@ -100,7 +100,7 @@
 .PHONY: tags
 
 tags:
-	ctags -R --exclude=data --exclude='public/jquery*' --exclude=public/bootstrap --exclude=public/doc --exclude=public/font-awesome --exclude=coverage --exclude=config .
+	ctags -R backends/ bin/ lib/ public/doc.js public/app.js public/style.css spec/ test/ tools/
 
 clean:
 	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS) man/

=== debian/changelog ===
debci (3.13) unstable; urgency=medium

  * Debci::Job.slow: fix comparison by using an integer input
  * api: add basic tests for the documentation app
  * api: fix crash on 404
  * api: /test: make `since` argument mandatory
  * api: /test: consider finish and publication dates in last timestamp
  * debci-test: limit the size of the artifacts directory
  * Debci::Package.storage_limit: use 8 bytes for storage
  * Debci::Admin: support floating point units for storage limit
  * admin: drop alert-style header
  * admin: handle validation errors
  * Debci::User: validate presence of username
  * Debci::Package: validate storage_limit
  * debci-test: fix warning message for removed artifacts
  * web ui: log_viewer: add "Retry" button
  * data import: don't copy foreign keys
  * Debci::Log: catch failures that happen without a "test results" marker
  * Enable Sinatra logging
  * Debci::AuthApp: always look for the current user
  * Fold Debci::AuthApp into Debci::App
  * Debci::App: prevent unnecessary cookies
  * home, frontend: hide package browsing behind login
  * web: redirect to original page when logging in
  * layout: add a link to the Self Service panel to the user menu
  * frontend: display retry links for logged users only
  * frontend: don't cache responses to logged in users
  * self_service: honor original url on explicit logins
  * self_service: ensure logged in user does not see login page
  * self_service: remove redundant code
  * web: restrict public browsing even more.

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 06 Dec 2025 11:53:14 -0300

=== test/test-package-large-artifacts/debian/tests/control ===
Tests: generate-large-artifacts
